//////////////////////////////////////////////////////////////////////////////////////////////////
// MatsEd V 2.0
// 
// The 2nd braindamaged material editogenerator 
// 2005 Torsten Fock aka fogman
// Credits to Timo Stark aka TripleX for Big.dll  :)

// Youre allowed to use MatsEd_2 for your projects.
// Youre allowed to copy MatsEd_2 and give it away.
// Youre NOT allowed to sell / resell MatsEd in any way.
// MatsEd is Freeware, but all rights are reserved by Torsten Fock.
//////////////////////////////////////////////////////////////////////////////////////////////////
path "data";
plugindir = "plugins"; 
//////////////////////////////////////////////////////////////////////////////////////////////////
string level_str = <matsed2.wmb>;
string filename; // String fr den Namen der aktuellen Entity. Zum lschen.
string materialname_str; // String fr Inkey Materialnameneingabe
string material_str;
string nullstring = "";
string temp_str; // String zur temporren Verwendung

string title_str = "File Open"; // Der Titel fr den File-open Dialog
string types_str;
string type_ent_str = "(*.mdl)|*.mdl|(*.bmp)|*.bmp|(*.pcx)|*.pcx|(*.tga)|*.tga|"; // Dateieinschrnkung File-open Dialog
string type_mtl_str = "(*.me2)|*.me2|"; // Dateieinschrnkung File-open Dialog
string FirstDirectory = " "; // Die Startdirectory des File-open Dialogs 
string knife_str = "lowbrowning.mdl"; 
string matsed_str = "MatsEd v 2.0  /  Material Editogenerator  /  2005 Torsten Fock  /  fogman@gmx.com"; 

string scale_str; // Erhlt die aktuelle Skalierung 

string button_move_str   = "Move / Rotate / Scale Entity";
string button_bulb_str   = "Move Lightbulb";
string button_panel_str  = "Adjust Values";
string button_open_str   = "Load Entity";
string button_export_str = "Export Material Definition";
string button_help_str   = "Open Helpfile";
string button_exit_str   = "Quit MatsEd";

string savename_str; // Erhlt die Namen der Save Settings Files
//////////////////////////////////////////////////////////////////////////////////////////////////
var language_var; // 1 = englisch / 2 = deutsch

var model_vec[3] = 128,-20,0; // Position an der das Model erstellt wird.
var model_scale = 1; // Mit dieser Variablen wird die Skalierung des Models verndert

var model_mode;  // 1 wenn Modelbutton ausgewhlt
var bulb_mode;   // 1 wenn Lightbutton ausgewhlt
var adjust_mode; // 1 wenn Einstellbutton ausgewhlt

var filehandle; // Handle fr File Anweisungen

var video_mode = 8;      // Starteinstellung fr 1024x768
var video_depth = 32;    // Starteinstellung fr 32 Bit Farbtiefe
var video_screen = 2;    // Starteinstellung fr Fenstermodus
var d3d_alphadepth = 32; // Tgas mit hoher Qualitt anzeigen

var dyn_red_var = 100;   // Die Variablen fr das dynamische Licht
var dyn_green_var = 100;
var dyn_blue_var = 100;
var dyn_lightrange_var = 100;

var ambient_blue_var   = 100; // Die Variablen fr die Materialmanipulation
var ambient_green_var  = 100;  
var ambient_red_var    = 100;  
var diffuse_blue_var   = 0;  
var diffuse_green_var  = 0;  
var diffuse_red_var    = 0;  
var specular_blue_var  = 0;  
var specular_green_var = 0;  
var specular_red_var   = 0;
var emissive_blue_var  = 0;  
var emissive_green_var = 0;  
var emissive_red_var   = 0; 
var power_var			  = 0;

var bright_var = 0;           // Weitere Variablen zum manipulieren der Flags
var flare_var = 0;
var overlay_var = 0;
var transparent_var = 0;
var alpha_var = 50;
var shadow_var = 0;

var buttnumber;
//////////////////////////////////////////////////////////////////////////////////////////////////
bmap mouse_bmap     = <mouse_map.pcx>;      // Mausemap
bmap pnl_bmap       = <pnl.pcx>;            // Hintergrundpanel
bmap sld_bmap       = <sld.bmp>;            // Sliderbitmap
bmap right_bmap     = <arrr.bmp>;           // Pfeil rechts
bmap left_bmap      = <arrl.bmp>;           // Pfeil links
bmap butt_default   = <butt_default.pcx>;   // Button "Default"
bmap butt_defaulton = <butt_defaulton.pcx>; // Button "Default On"
bmap butt_rnd       = <butt_rnd.pcx>;       // Button "Randomize"
bmap butt_rndon     = <butt_rndon.pcx>;     // Button "Randomize On"

bmap buttons_pnl_bmap = <buttons_panel.pcx>; // Panel fr die Edit Buttons

bmap ico_exiton       = <ico_exiton.pcx>; // Die Edit Buttons / ON  // -Quit MatsED
bmap ico_exporton     = <ico_exporton.pcx>;                         // -Export Material
bmap ico_helpon       = <ico_helpon.pcx>;                           // -Open Helpfile
bmap ico_bulbon       = <ico_bulbon.pcx>;                           // -Move Bulb
bmap ico_moveon       = <ico_moveon.pcx>;                           // -Move/Rotate/Scale Entity
bmap ico_openon       = <ico_openon.pcx>;                           // -Open Entity
bmap ico_panelon      = <ico_panelon.pcx>;                          // -Adjust Material
bmap ico_openon_mtl   = <ico_openon_mtl.pcx>;                       // -Load Settings
bmap ico_saveon_mtl   = <ico_exporton_mtl.pcx>;                       // -Save Settings

bmap ico_exit       = <ico_exit.pcx>; // Die Edit Buttons / OFF 
bmap ico_export     = <ico_export.pcx>;
bmap ico_help       = <ico_help.pcx>;
bmap ico_bulb       = <ico_bulb.pcx>;
bmap ico_move       = <ico_move.pcx>;
bmap ico_open       = <ico_open.pcx>;
bmap ico_panel      = <ico_panel.pcx>;
bmap ico_open_mtl   = <ico_open_mtl.pcx>;
bmap ico_save_mtl   = <ico_export_mtl.pcx>;

bmap ico_exitov       = <ico_exitov.pcx>; // Die Edit Buttons / OVER 
bmap ico_exportov     = <ico_exportov.pcx>;
bmap ico_helpov       = <ico_helpov.pcx>;
bmap ico_bulbov       = <ico_bulbov.pcx>;
bmap ico_moveov       = <ico_moveov.pcx>;
bmap ico_openov       = <ico_openov.pcx>;
bmap ico_panelov      = <ico_panelov.pcx>;
bmap ico_openov_mtl   = <ico_openov_mtl.pcx>;
bmap ico_saveov_mtl   = <ico_exportov_mtl.pcx>;

bmap inkey_matname_bmap  = <inkey_matname.pcx>;
bmap export_true         = <export_true.pcx>;
bmap export_false        = <export_false.pcx>;

bmap inkey_savesettings_bmap = <inkey_savesettings.pcx>;

bmap welcome_bmap = <welcome.pcx>;
bmap butt_ger     = <buttger.pcx>;
bmap butt_geron   = <buttgeron.pcx>;
bmap butt_eng     = <butteng.pcx>;
bmap butt_engon   = <buttengon.pcx>;
//////////////////////////////////////////////////////////////////////////////////////////////////
font arial_font =	"Arial",1,12; // truetype font
//////////////////////////////////////////////////////////////////////////////////////////////////
entity* mdl_ptr; // Entitypointer
//////////////////////////////////////////////////////////////////////////////////////////////////
include <Freedll.wdl>; // Das Script zum Plugin
include <txt.wdl>; // Das Script mit allen Texten
//////////////////////////////////////////////////////////////////////////////////////////////////
function open_file_fnc(); // Ein paar Prototypen
function export_fnc();
function exit_fnc();
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
function button_fnc(button_number) // Funktion fr die Pfeilbuttons
{
	if(button_number ==  1){dyn_red_var- = 1;}
	if(button_number ==  2){dyn_red_var+ = 1;}
	
	if(button_number ==  3){dyn_green_var- = 1;}
	if(button_number ==  4){dyn_green_var+ = 1;}
	
	if(button_number ==  5){dyn_blue_var- = 1;}
	if(button_number ==  6){dyn_blue_var+ = 1;}
	
	if(button_number ==  7){dyn_lightrange_var- = 1;}
	if(button_number ==  8){dyn_lightrange_var+ = 1;}
	
	if(button_number == 9){ambient_red_var- = 1;}
	if(button_number == 10){ambient_red_var+ = 1;}
	
	if(button_number == 11){ambient_green_var- = 1;}
	if(button_number == 12){ambient_green_var+ = 1;}
	
	if(button_number == 13){ambient_blue_var- = 1;}
	if(button_number == 14){ambient_blue_var+ = 1;}	
	
	if(button_number == 15){diffuse_red_var- = 1;}
	if(button_number == 16){diffuse_red_var+ = 1;}
	
	if(button_number == 17){diffuse_green_var- = 1;}
	if(button_number == 18){diffuse_green_var+ = 1;}
	
	if(button_number == 19){diffuse_blue_var- = 1;}
	if(button_number == 20){diffuse_blue_var+ = 1;}	
	
	if(button_number == 21){specular_red_var- = 1;}
	if(button_number == 22){specular_red_var+ = 1;}
	
	if(button_number == 23){specular_green_var- = 1;}
	if(button_number == 24){specular_green_var+ = 1;}
	
	if(button_number == 25){specular_blue_var- = 1;}
	if(button_number == 26){specular_blue_var+ = 1;}	
	
	if(button_number == 27){emissive_red_var- = 1;}
	if(button_number == 28){emissive_red_var+ = 1;}
	
	if(button_number == 29){emissive_green_var- = 1;}
	if(button_number == 30){emissive_green_var+ = 1;}
	
	if(button_number == 31){emissive_blue_var- = 1;}
	if(button_number == 32){emissive_blue_var+ = 1;}
	
	if(button_number == 33){power_var- = 1;}
	if(button_number == 34){power_var+ = 1;}
	
	if(button_number == 35){bright_var- = 1;}
	if(button_number == 36){bright_var+ = 1;}
	
	if(button_number == 37){flare_var- = 1;}
	if(button_number == 38){flare_var+ = 1;}
	
	if(button_number == 39){overlay_var- = 1;}
	if(button_number == 40){overlay_var+ = 1;}
	
	if(button_number == 41){transparent_var- = 1;}
	if(button_number == 42){transparent_var+ = 1;}
	
	if(button_number == 43){alpha_var- = 1;}
	if(button_number == 44){alpha_var+ = 1;}
	
	if(button_number == 45){shadow_var- = 1;}
	if(button_number == 46){shadow_var+ = 1;}	
	
	if(button_number == 47){mip_flat- = 1;}
	if(button_number == 48){mip_flat+ = 1;}
	
	if(button_number == 49){mip_shaded- = 1;}
	if(button_number == 50){mip_shaded+ = 1;}
	
	if(button_number == 51){mip_sprites- = 1;}
	if(button_number == 52){mip_sprites+ = 1;}
	
	if(button_number == 53){d3d_mipmapping- = 1;}
	if(button_number == 54){d3d_mipmapping+ = 1;}

	if(button_number == 55){d3d_lightres- = 1;}
	if(button_number == 56){d3d_lightres+ = 1;}				
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
panel slider_pnl // Das Panel mit allen Slidern und Pfeilbuttons
{
	bmap = pnl_bmap;
	layer = 3;
	
	hslider = 30,  36, 160, sld_bmap, 0, 255, dyn_red_var;
	digits = 230,  36, 3, arial_font, 1, dyn_red_var;
	button =  20,  37, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190,  37, right_bmap, right_bmap, right_bmap, button_fnc, null, null;
	
	hslider = 30,  54, 160, sld_bmap, 0, 255, dyn_green_var;
	digits = 230,  54, 3, arial_font, 1, dyn_green_var;
	button =  20,  55, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190,  55, right_bmap, right_bmap, right_bmap, button_fnc, null, null;

	hslider = 30,  72, 160, sld_bmap, 0, 255, dyn_blue_var;
	digits = 230,  72, 3, arial_font, 1, dyn_blue_var;	
	button =  20,  73, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190,  73, right_bmap, right_bmap, right_bmap, button_fnc, null, null;
	
	hslider = 30,  99, 160, sld_bmap, 0, 999, dyn_lightrange_var;
	digits = 230,  99, 3, arial_font, 1, dyn_lightrange_var;
	button =  20, 100, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 100, right_bmap, right_bmap, right_bmap, button_fnc, null, null;

	
	hslider = 30, 135, 160, sld_bmap, 0, 255, ambient_red_var;
	digits = 230, 135, 3, arial_font, 1, ambient_red_var;
	button =  20, 136, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 136, right_bmap, right_bmap, right_bmap, button_fnc, null, null;
	
	hslider = 30, 153, 160, sld_bmap, 0, 255, ambient_green_var;
	digits = 230, 153, 3, arial_font, 1, ambient_green_var;
	button =  20, 154, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 154, right_bmap, right_bmap, right_bmap, button_fnc, null, null;
	
	hslider = 30, 171, 160, sld_bmap, 0, 255, ambient_blue_var;
	digits = 230, 171, 3, arial_font, 1, ambient_blue_var;
	button =  20, 172, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 172, right_bmap, right_bmap, right_bmap, button_fnc, null, null;	

	
	hslider = 30, 198, 160, sld_bmap, 0, 255, diffuse_red_var;
	digits = 230, 198, 3, arial_font, 1, diffuse_red_var;	
	button =  20, 199, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 199, right_bmap, right_bmap, right_bmap, button_fnc, null, null;	
	
	hslider = 30, 216, 160, sld_bmap, 0, 255, diffuse_green_var;
	digits = 230, 216, 3, arial_font, 1, diffuse_green_var;	
	button =  20, 217, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 217, right_bmap, right_bmap, right_bmap, button_fnc, null, null;	
	
	hslider = 30, 234, 160, sld_bmap, 0, 255, diffuse_blue_var;
	digits = 230, 234, 3, arial_font, 1, diffuse_blue_var;
	button =  20, 235, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 235, right_bmap, right_bmap, right_bmap, button_fnc, null, null;
	
	
	hslider = 30, 261, 160, sld_bmap, 0, 255, specular_red_var;
	digits = 230, 261, 3, arial_font, 1, specular_red_var;
	button =  20, 262, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 262, right_bmap, right_bmap, right_bmap, button_fnc, null, null;	

	hslider = 30, 279, 160, sld_bmap, 0, 255, specular_green_var;
	digits = 230, 279, 3, arial_font, 1, specular_green_var;	
	button =  20, 280, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 280, right_bmap, right_bmap, right_bmap, button_fnc, null, null;	
	
	hslider = 30, 297, 160, sld_bmap, 0, 255, specular_blue_var;
	digits = 230, 297, 3, arial_font, 1, specular_blue_var;	
	button =  20, 298, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 298, right_bmap, right_bmap, right_bmap, button_fnc, null, null;	
	
	
	hslider = 30, 324, 160, sld_bmap, 0, 255, emissive_red_var;
	digits = 230, 324, 3, arial_font, 1, emissive_red_var;	
	button =  20, 325, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 325, right_bmap, right_bmap, right_bmap, button_fnc, null, null;	
	
	hslider = 30, 342, 160, sld_bmap, 0, 255, emissive_green_var;
	digits = 230, 342, 3, arial_font, 1, emissive_green_var;
	button =  20, 343, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 343, right_bmap, right_bmap, right_bmap, button_fnc, null, null;	
	
	hslider = 30, 360, 160, sld_bmap, 0, 255, emissive_blue_var;
	digits = 230, 360, 3, arial_font, 1, emissive_blue_var;
	button =  20, 361, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 361, right_bmap, right_bmap, right_bmap, button_fnc, null, null;	
	
	
	hslider = 30, 387, 160, sld_bmap, 0, 50, power_var;
	digits = 230, 387, 3, arial_font, 1, power_var;
	button =  20, 388, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 388, right_bmap, right_bmap, right_bmap, button_fnc, null, null;

	
	hslider = 30, 414, 160, sld_bmap, 0, 1, bright_var;
	digits = 230, 414, 3, arial_font, 1, bright_var;
	button =  20, 415, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 415, right_bmap, right_bmap, right_bmap, button_fnc, null, null;	
	
	hslider = 30, 432, 160, sld_bmap, 0, 1, flare_var;
	digits = 230, 432, 3, arial_font, 1, flare_var;
	button =  20, 433, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 433, right_bmap, right_bmap, right_bmap, button_fnc, null, null;	
	
	hslider = 30, 450, 160, sld_bmap, 0, 1, overlay_var;
	digits = 230, 450, 3, arial_font, 1, overlay_var;
	button =  20, 451, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 451, right_bmap, right_bmap, right_bmap, button_fnc, null, null;	
	
	hslider = 30, 468, 160, sld_bmap, 0, 1, transparent_var;
	digits = 230, 468, 3, arial_font, 1, transparent_var;
	button =  20, 469, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 469, right_bmap, right_bmap, right_bmap, button_fnc, null, null;	
	
	hslider = 30, 486, 160, sld_bmap, 0, 100, alpha_var;
	digits = 230, 486, 3, arial_font, 1, alpha_var;
	button =  20, 487, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 487, right_bmap, right_bmap, right_bmap, button_fnc, null, null;	
	
	hslider = 30, 504, 160, sld_bmap, 0, 1, shadow_var;
	digits = 230, 504, 3, arial_font, 1, shadow_var;
	button =  20, 505, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 505, right_bmap, right_bmap, right_bmap, button_fnc, null, null;	
	
	
	hslider = 30, 522, 160, sld_bmap, 0, 10, mip_flat;
	digits = 230, 522, 3, arial_font, 1, mip_flat;
	button =  20, 523, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 523, right_bmap, right_bmap, right_bmap, button_fnc, null, null;	
	
	hslider = 30, 540, 160, sld_bmap, 0, 10, mip_shaded;
	digits = 230, 540, 3, arial_font, 1, mip_shaded;
	button =  20, 541, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 541, right_bmap, right_bmap, right_bmap, button_fnc, null, null;	
	
	hslider = 30, 558, 160, sld_bmap, 0, 10, mip_sprites;
	digits = 230, 558, 3, arial_font, 1, mip_sprites;	
	button =  20, 559, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 559, right_bmap, right_bmap, right_bmap, button_fnc, null, null;		


	hslider = 30, 576, 160, sld_bmap, 0, 3, d3d_mipmapping;
	digits = 230, 576, 3, arial_font, 1, d3d_mipmapping;
	button =  20, 577, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 577, right_bmap, right_bmap, right_bmap, button_fnc, null, null;
	
	hslider = 30, 594, 160, sld_bmap, 0, 1, d3d_lightres;
	digits = 230, 594, 3, arial_font, 1, d3d_lightres;
	button =  20, 595, left_bmap, left_bmap, left_bmap, button_fnc, null, null;
	button = 190, 595, right_bmap, right_bmap, right_bmap, button_fnc, null, null;	
	
	button = 240, 630, butt_defaulton, butt_default, butt_default, default_fnc, null, null;
	button = 240, 680, butt_rndon, butt_rnd, butt_rnd, randomize_fnc, null, null;	
	
	button =  50, 630, ico_openon_mtl, ico_open_mtl, ico_open_mtl, load_settings_fnc, null, null;
	button =  50, 680, ico_saveon_mtl, ico_save_mtl, ico_save_mtl, save_settings_fnc, null, null;

	flags = overlay;	
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
function button_description(button_number) // Ein + Ausblenden der Buttonbeschreibungen
{
	buttnumber = button_number;
	
	while(buttnumber == 1)&&(mouse_pos.x > 630)&&(mouse_pos.y > 678)
	{
		draw_text(button_move_str,mouse_pos.x-20,mouse_pos.y-60,vector(240,240,240));
		wait(1);
	}
	while(buttnumber == 2)&&(mouse_pos.x > 630)&&(mouse_pos.y > 678)
	{
		draw_text(button_bulb_str,mouse_pos.x-20,mouse_pos.y-60,vector(240,240,240));
		wait(1);
	}
	while(buttnumber == 3)&&(mouse_pos.x > 630)&&(mouse_pos.y > 678)
	{
		draw_text(button_panel_str,mouse_pos.x-20,mouse_pos.y-60,vector(240,240,240));
		wait(1);
	}
	while(buttnumber == 4)&&(mouse_pos.x > 630)&&(mouse_pos.y > 678)
	{
		draw_text(button_open_str,mouse_pos.x-20,mouse_pos.y-60,vector(240,240,240));
		wait(1);
	}
	while(buttnumber == 5)&&(mouse_pos.x > 630)&&(mouse_pos.y > 678)
	{
		draw_text(button_export_str,mouse_pos.x-80,mouse_pos.y-60,vector(240,240,240));
		wait(1);
	}
	while(buttnumber == 6)&&(mouse_pos.x > 630)&&(mouse_pos.y > 678)
	{
		draw_text(button_help_str,mouse_pos.x-60,mouse_pos.y-60,vector(240,240,240));
		wait(1);
	}
	while(buttnumber == 7)&&(mouse_pos.x > 630)&&(mouse_pos.y > 678)
	{
		draw_text(button_exit_str,mouse_pos.x-80,mouse_pos.y-60,vector(240,240,240));
		wait(1);
	}
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
function buttons_fnc(button_number)
{
	if(button_number == 1) // Model Move
	{
		model_mode = 1;
		bulb_mode = 0;
		adjust_mode = 0;
		slider_pnl.visible = off;
		slidernames_txt.visible = off;
	}
	if(button_number == 2) // Bulb Move
	{
		model_mode = 0;
		bulb_mode = 1;
		adjust_mode = 0;
		slider_pnl.visible = off;
		slidernames_txt.visible = off;
	}	
	if(button_number == 3) // Adjust Values
	{
		model_mode = 0;
		bulb_mode = 0;
		adjust_mode = 1;
		slider_pnl.visible = on;
		slidernames_txt.visible = on;
	}
	if(button_number == 4) // Load Entity
	{
		model_mode = 0;
		bulb_mode = 0;
		adjust_mode = 0;
		slider_pnl.visible = off;
		slidernames_txt.visible = off;
		open_file_fnc();
	}
	if(button_number == 5) // Export Material Definition
	{
		model_mode = 0;
		bulb_mode = 0;
		adjust_mode = 0;
		slider_pnl.visible = off;
		slidernames_txt.visible = off;
		export_fnc();
	}
	if(button_number == 6) // Open Helpfile
	{
		model_mode = 0;
		bulb_mode = 0;
		adjust_mode = 1;
		if(language_var == 1){DllOpenFileAbsolut("MatsEdManual_eng.html");}
		if(language_var == 2){DllOpenFileAbsolut("MatsEdManual_de.html");}
	}
	if(button_number == 7) // Quit MatsEd
	{
		model_mode = 0;
		bulb_mode = 0;
		adjust_mode = 0;
		slider_pnl.visible = off;
		slidernames_txt.visible = off;
		exit_fnc();
	}		
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
panel buttons_pnl // Das Panel mit den Edit-Buttons
{
	bmap = buttons_pnl_bmap;
	layer = 3;
	pos_x = 640;
	pos_y = 688;
	button =   0, 0,   ico_moveon,   ico_move,   ico_moveov,   buttons_fnc, null, button_description;	
	button =  54, 0,   ico_bulbon,   ico_bulb,   ico_bulbov,   buttons_fnc, null, button_description;
	button = 108, 0,   ico_panelon,  ico_panel,  ico_panelov,  buttons_fnc, null, button_description;	
	button = 162, 0,   ico_openon,   ico_open,   ico_openov,   buttons_fnc, null, button_description;	
	button = 216, 0,   ico_exporton, ico_export, ico_exportov, buttons_fnc, null, button_description;
	button = 270, 0,   ico_helpon,   ico_help,   ico_helpov,   buttons_fnc, null, button_description;
	button = 324, 0,   ico_exiton,   ico_exit,   ico_exitov,   buttons_fnc, null, button_description;		
	flags = visible;	
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
material matsed_mat 
{  
	ambient_blue   = 0;  
	ambient_green  = 0;  
	ambient_red    = 0;  
	diffuse_blue   = 0;  
	diffuse_green  = 0;  
	diffuse_blue   = 0;  
	specular_blue  = 0;  
	specular_green = 0;  
	specular_red   = 0;
	emissive_blue  = 0;  
	emissive_green = 0;  
	emissive_red   = 0;  
	power          = 0;
}
//////////////////////////////////////////////////////////////////////////////////////////////////
material* my_mat = matsed_mat; // Materialpointer
//////////////////////////////////////////////////////////////////////////////////////////////////
function rotate_fnc // Das Model mit der Maus drehen und Material zuweisen.
{
	my.scale_x = 1;
	my.scale_y = 1;
	my.scale_z = 1;
	model_scale = 1;
	mdl_ptr = me;
	my.material = matsed_mat;
	while(mdl_ptr != null)
	{	
		my_mat.ambient_blue   = ambient_blue_var;  
		my_mat.ambient_green  = ambient_green_var;  
		my_mat.ambient_red    = ambient_red_var;  
		my_mat.diffuse_blue   = diffuse_blue_var;  
		my_mat.diffuse_green  = diffuse_green_var;  
		my_mat.diffuse_red    = diffuse_red_var;  
		my_mat.specular_blue  = specular_blue_var;  
		my_mat.specular_green = specular_green_var;  
		my_mat.specular_red   = specular_red_var;
		my_mat.emissive_blue  = emissive_blue_var;  
		my_mat.emissive_green = emissive_green_var;  
		my_mat.emissive_red   = emissive_red_var;  
		my_mat.power          = power_var;
		
		my.bright = bright_var;
		my.flare = flare_var;
		my.overlay = overlay_var;
		my.transparent = transparent_var;
		my.alpha = alpha_var;
		my.shadow = shadow_var;	
		if(model_mode == 1)&&(mouse_right)
		{
			my.pan-  = mouse_force.x * 30 * time;
			my.tilt+ = mouse_force.y * 30 * time;
		}
		if(model_mode == 1)&&(mouse_left)
		{
			my.y- = mouse_force.x * 10 * time;
			my.z+ = mouse_force.y * 10 * time;
			my.y = min(70,(max(my.y, -70)));
			my.z = min(50,(max(my.z, -50)));
		}
		if(model_mode == 1)
		{
			model_scale+ = mickey.z * 0.002 * time;
			my.scale_x = model_scale;
			my.scale_y = model_scale;
			my.scale_z = model_scale;
			model_scale = min(100,(max(model_scale, 0.002)));
		}
		wait(1);
	}	
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
action dynlight_act // Das dynamische Licht
{
	while(1)
	{
		my.red   = dyn_red_var;
		my.green = dyn_green_var;
		my.blue  = dyn_blue_var;
		my.lightrange = dyn_lightrange_var;
		if(mouse_left)&&(bulb_mode == 1)
		{
			my.y- = mouse_force.x * 10 * time;
			my.z+ = mouse_force.y * 10 * time;
		}
		if(mouse_right)&&(bulb_mode == 1)
		{
			my.x+ = mouse_force.y * 10 * time;
		}
		my.y = min(70,(max(my.y, -70)));
		my.z = min(50,(max(my.z, -50)));
		my.x = min(200,(max(my.x, 70)));
		wait(1);			
	}
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
function export_fnc // Schreibt die Materialdefinition in materials.txt
{
	buttnumber = 0;
	mouse_pointer = 0;
	mouse_mode = 0;
	buttons_pnl.visible = off; // Editbuttons unsichtbar
	inkey_txt.visible = on; // Inkey Text sichtbar
	inkey_pnl.visible = on; // Inkey Panel sichtbar
	inkey(materialname_str); // Eingabe Materialname
	if(result != 13) // Falls Userabbruch
	{
		inkey_txt.visible = off;
		inkey_pnl.bmap = export_false;
		sleep(0.7);
		inkey_pnl.visible = off;
		inkey_pnl.bmap = inkey_matname_bmap;
		buttons_pnl.visible = on;
		mouse_pointer = 1;
		model_mode = 1;
		mouse_mode = 1;		
		return; // Funktion beenden
	}
	str_cpy(material_str, "material ");
	str_cat(material_str, materialname_str);
	
	filehandle = file_open_append("materials.txt");
	file_str_write(filehandle, material_str);
	file_str_write(filehandle,"
	{
	ambient_red = ");
	file_var_write(filehandle, int(ambient_red_var));
	file_str_write(filehandle,";
	");
	
	file_str_write(filehandle, "ambient_green = ");
	file_var_write(filehandle, int(ambient_green_var));
	file_str_write(filehandle,";
	");
	
	file_str_write(filehandle, "ambient_blue = ");
	file_var_write(filehandle, int(ambient_blue_var));
	file_str_write(filehandle,";
	");
	
	file_str_write(filehandle, "diffuse_red = ");
	file_var_write(filehandle, int(diffuse_red_var));
	file_str_write(filehandle,";
	");
	
	file_str_write(filehandle, "diffuse_green = ");
	file_var_write(filehandle, int(diffuse_green_var));
	file_str_write(filehandle,";
	");
	
	file_str_write(filehandle, "diffuse_blue = ");
	file_var_write(filehandle, int(diffuse_blue_var));
	file_str_write(filehandle,";
	");
	
	file_str_write(filehandle, "specular_red = ");
	file_var_write(filehandle, int(specular_red_var));
	file_str_write(filehandle,";
	");
	
	file_str_write(filehandle, "specular_green = ");
	file_var_write(filehandle, int(specular_green_var));
	file_str_write(filehandle,";
	");
	
	file_str_write(filehandle, "specular_blue = ");
	file_var_write(filehandle, int(specular_blue_var));
	file_str_write(filehandle,";
	");
	
	file_str_write(filehandle, "emissive_red = ");
	file_var_write(filehandle, int(emissive_red_var));
	file_str_write(filehandle,";
	");
	
	file_str_write(filehandle, "emissive_green = ");
	file_var_write(filehandle, int(emissive_green_var));
	file_str_write(filehandle,";
	");
	
	file_str_write(filehandle, "emissive_blue = ");
	file_var_write(filehandle, int(emissive_blue_var));
	file_str_write(filehandle,";
	");
	
	file_str_write(filehandle, "power = ");
	file_var_write(filehandle, int(power_var));
	file_str_write(filehandle,";
	}
	");
	
	file_close(filehandle);
	
	inkey_txt.visible = off;
	inkey_pnl.bmap = export_true;
	sleep(0.7);
	inkey_pnl.visible = off;
	inkey_pnl.bmap = inkey_matname_bmap;
	buttons_pnl.visible = on;
	model_mode = 1;
	mouse_pointer = 1;
	mouse_mode = 1;
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
function open_file_fnc
{
	slider_pnl.visible = off;
	slidernames_txt.visible = off;
	if(str_len(filename)> 0){file_delete(filename);} // Falls eine Entitiy geladen wurde lsche sie
	str_cpy(types_str, type_ent_str); // String fr Dateitypen auf Entities
	mouse_map = null;
	mouse_sync = 1;
	DllOpenFile(title_str,types_str,FirstDirectory); // Open Dialog
	DllCopyFileAbsToRel(DllReceiveStr2,DllReceiveStr1); // Datei wird kopiert
	mouse_map = mouse_bmap;
	mouse_sync = 0;	 
	if(mdl_ptr) { ent_remove(mdl_ptr);} // Alte Entity entfernen
	str_cpy(filename, DllReceiveStr1); // String fllen, Entity geladen
	ent_create(DllReceiveStr1, model_vec, rotate_fnc); // Create die kopierte Entity
	model_mode = 1; // Move/Rotate/Scale einschalten
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
function save_settings_fnc // Abspeichern der Settings
{
	buttnumber = 0;
	mouse_pointer = 0;
	mouse_mode = 0;
	buttons_pnl.visible = off;
	inkey_save_settings_pnl.visible = on;
	inkey2_txt.visible = on;
	inkey(savename_str);
	if(result != 13) // Falls Userabbruch
	{
		inkey_save_settings_pnl.visible = off;
		inkey_pnl.bmap = export_false;
		inkey_pnl.visible = on;
		sleep(0.7);
		inkey_pnl.visible = off;
		inkey_pnl.bmap = inkey_matname_bmap;
		buttons_pnl.visible = on;
		mouse_pointer = 1;
		model_mode = 1;
		mouse_mode = 1;		
		return; // Funktion beenden
	}

	str_cat(savename_str, ".me2");
	filehandle = file_open_write(savename_str);
	
	file_var_write(filehandle, int(dyn_red_var));
	file_var_write(filehandle, int(dyn_green_var));
	file_var_write(filehandle, int(dyn_blue_var));
	file_var_write(filehandle, int(dyn_lightrange_var));	
	
	file_var_write(filehandle, int(ambient_red_var));
	file_var_write(filehandle, int(ambient_green_var));
	file_var_write(filehandle, int(ambient_blue_var));
	
	file_var_write(filehandle, int(diffuse_red_var));
	file_var_write(filehandle, int(diffuse_green_var));
	file_var_write(filehandle, int(diffuse_blue_var));

	file_var_write(filehandle, int(specular_red_var));
	file_var_write(filehandle, int(specular_green_var));
	file_var_write(filehandle, int(specular_blue_var));

	file_var_write(filehandle, int(emissive_red_var));
	file_var_write(filehandle, int(emissive_green_var));
	file_var_write(filehandle, int(emissive_blue_var));
	
	file_var_write(filehandle, bright_var);
	file_var_write(filehandle, flare_var);
	file_var_write(filehandle, overlay_var);
	file_var_write(filehandle, transparent_var);
	file_var_write(filehandle, alpha_var);
	
	file_var_write(filehandle, mip_shaded);	
	file_var_write(filehandle, mip_flat);	
	file_var_write(filehandle, mip_sprites);	
	file_var_write(filehandle, d3d_mipmapping);
	file_var_write(filehandle, d3d_lightres);
	
	file_close(filehandle);
	
	inkey2_txt.visible = off;
	inkey_save_settings_pnl.visible = off;
	inkey_pnl.bmap = export_true;
	inkey_pnl.visible = on;
	sleep(0.7);
	inkey_pnl.visible = off;
	inkey_pnl.bmap = inkey_matname_bmap;
	buttons_pnl.visible = on;
	mouse_pointer = 1;
	model_mode = 1;
	mouse_mode = 1;	
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
function load_settings_fnc // Laden der Settings
{
	model_mode = 0;
	bulb_mode = 0;
	adjust_mode = 0;
	str_cpy(types_str, type_mtl_str); // String fr Dateitypen auf Entities
	mouse_map = null;
	mouse_mode = 0;
	mouse_pointer = 0;
	mouse_sync = 1;
	DllOpenFile(title_str,types_str,FirstDirectory); // Open Dialog
	if(str_len(DllReceiveStr1)==0)
	{
		mouse_map = mouse_bmap;
		mouse_mode = 1;
		mouse_pointer = 1;
		mouse_sync = 0;
		adjust_mode = 1;		
		return;
	}
	filehandle = file_open_read(DllReceiveStr1);

	dyn_red_var = file_var_read(filehandle);
	dyn_green_var = file_var_read(filehandle);
	dyn_blue_var = file_var_read(filehandle);
	dyn_lightrange_var = file_var_read(filehandle);	
	
	ambient_red_var = file_var_read(filehandle);
	ambient_green_var = file_var_read(filehandle);
	ambient_blue_var = file_var_read(filehandle);
	
	diffuse_red_var = file_var_read(filehandle);
	diffuse_green_var = file_var_read(filehandle);
	diffuse_blue_var = file_var_read(filehandle);
	
	specular_red_var = file_var_read(filehandle);
	specular_green_var = file_var_read(filehandle);
	specular_blue_var = file_var_read(filehandle);

	emissive_red_var = file_var_read(filehandle);
	emissive_green_var = file_var_read(filehandle);
	emissive_blue_var = file_var_read(filehandle);
	
	bright_var = file_var_read(filehandle);
	flare_var = file_var_read(filehandle);
	overlay_var = file_var_read(filehandle);
	transparent_var = file_var_read(filehandle);
	alpha_var = file_var_read(filehandle);	
	
	mip_flat = file_var_read(filehandle);
	mip_shaded = file_var_read(filehandle);
	mip_sprites = file_var_read(filehandle);
	d3d_mipmapping = file_var_read(filehandle);		
	d3d_lightres = file_var_read(filehandle);
	
	file_close(filehandle);

	mouse_map = mouse_bmap;
	mouse_mode = 1;
	mouse_pointer = 1;
	mouse_sync = 0;
	adjust_mode = 1;		
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
function exit_fnc // MatsEd beenden
{
	if(str_len(filename)> 0){file_delete(filename);} // Falls eine Entitiy geladen wurde lsche sie
	filehandle = file_open_write("config.cfg");
	file_var_write(filehandle, language_var);
	file_close(filehandle);	
	DllHandle = dll_close("Bigdll.dll");
	exit;
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
function language_choose
{
	if(language_var == 0)
	{
		model_mode = 0;
		buttons_pnl.visible = off;
		welcome_pnl.visible = on;
	}
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
function eng_choose_fnc
{
	language_var = 1;
	model_mode = 1;
	buttons_pnl.visible = on;
	welcome_pnl.visible = off;
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
function ger_choose_fnc
{
	language_var = 2;
	model_mode = 1;
	buttons_pnl.visible = on;
	welcome_pnl.visible = off;
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
function main()
{
	randomize();
	mouse_mode = 0;
	video_window(nullvector,nullvector,0,matsed_str);
	freeze_mode = 1;
	load_level(level_str);
	wait(3);
	freeze_mode = 0;
	
	filehandle     = file_open_read("config.cfg");
	language_var   = file_var_read(filehandle);
	file_close(filehandle);	
	
	mouse_map = mouse_bmap;
	wait(1);
	mouse_mode = 1;
	mouse_pointer = 1;
	mouse_sync = 0;
	if(mdl_ptr == null) {ent_create(knife_str, model_vec, rotate_fnc);}
	model_mode = 1;
	language_choose();
	while(1)
	{
		str_for_num (scale_str, model_scale);
		draw_text(scale_str,970,10,vector(200,200,200));
		draw_text("Entity Scale: ",850,10,vector(200,200,200));
		mouse_pos.x = pointer.x;
		mouse_pos.y = pointer.y;	
		wait(1);
	}
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
on_esc = exit_fnc;
on_close = exit_fnc;
on_esc = null;
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////


